/*
 *	close.c
 *
 * if we still have packets for that socket stored, free them now.
 */
#include "netbug.h"

int __libc_close(int);

int close(fd)
int fd;
{
  struct _netbug_buf *stored;

  for ( ; (stored = _netbug_search_stored_send_packet(fd)); stored->fd = -1) {
    /* maybe we just send the stored packet now */
  }

  for ( ; (stored = _netbug_search_stored_recv_packet(fd)); stored->fd = -1)
    continue;

  return __libc_close(fd);

}
