/*
 *	read.c
 */
#include "netbug.h"
#include <linux/net.h>


#define FUNC_NAME "read"

int __libc_read(int, void *, size_t);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _from, _fromlen) \
  __libc_read((_fd), (void*)  (_buf), (_len))
	
#define GETSRCPORT(_fd, _a, _from, _fromlen) \
  if (SOCK_DGRAM == opt) { \
    (_a) = (struct sockaddr_in *)&(_from); \
    (_a)->sin_port = 0; \
    (_fromlen) = sizeof (_from); \
    if (getpeername((_fd), (struct sockaddr *)&(_from), &(_fromlen)) \
        && errno \
        && ENOTCONN != errno \
        && ENOTSOCK != errno) \
      perror(STRINGJOIN(FUNC_NAME, "/getpeername")); \
  }

#define COPY_STOREDPACKET(_stored, _ret) \
{ \
  int tmpfromlen, tmpret; \
  tmpfromlen = MIN(*fromlen, (_stored)->addrlen); \
  memcpy(from, &(_stored)->addr, tmpfromlen); \
  *fromlen = tmpfromlen; \
  tmpret = MIN((_stored)->len, len); \
  memcpy(buf, (_stored)->buf, tmpret); \
  (_ret) = tmpret; \
}

int read(int fd, void *buf, size_t len)
{
  struct sockaddr dummyaddr, *from = &dummyaddr;
  int dummylen = sizeof dummyaddr, *fromlen = &dummylen;
  memset(&dummyaddr, '\0', sizeof dummyaddr);

#include "recv-common.ic"

}
