/*
 *	recv.c
 */
#include "netbug.h"

#define FUNC_NAME "recv"

int __libc_recv(int, void *, size_t, int);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _from, _fromlen) \
  __libc_recv((_fd), (_buf), (_len), (_flags))

#define GETSRCPORT(_fd, _a, _from, _fromlen) \
  if (SOCK_DGRAM == opt) { \
    (_a) = (struct sockaddr_in *)&(_from); \
    (_a)->sin_port = 0; \
    (_fromlen) = sizeof (_from); \
    if (getpeername((_fd), (struct sockaddr *)&(_from), &(_fromlen)) \
        && errno \
        && ENOTCONN != errno \
        && ENOTSOCK != errno) \
      perror(STRINGJOIN(FUNC_NAME, "/getpeername")); \
  }

#define COPY_STOREDPACKET(_stored, _ret) \
{ \
  int tmpfromlen, tmpret; \
  tmpfromlen = MIN(*fromlen, (_stored)->addrlen); \
  memcpy(from, &(_stored)->addr, tmpfromlen); \
  *fromlen = tmpfromlen; \
  tmpret = MIN((_stored)->len, len); \
  memcpy(buf, (_stored)->buf, tmpret); \
  (_ret) = tmpret; \
}

int recv(int fd, void *buf, size_t len, int flags)
{
  struct sockaddr dummyaddr, *from = &dummyaddr;
  int dummylen = sizeof dummyaddr, *fromlen = &dummylen;
  memset(&dummyaddr, '\0', sizeof dummyaddr);

#include "recv-common.ic"

}
