/*
 *	recvmsg.c
 */
#include "netbug.h"

#define FUNC_NAME "recvmsg"

int __libc_recvmsg(int, struct msghdr *, int);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _from, _fromlen) \
  __libc_recvmsg((_fd), (struct msghdr*) (_buf), (_flags))
    
#define GETSRCPORT(_fd, _a, _from, _fromlen) \
  if (SOCK_DGRAM == opt) { \
    (_a) = (struct sockaddr_in *)&(_from); \
    (_a)->sin_port = 0; \
    (_fromlen) = sizeof (_from); \
    if (getpeername((_fd), (struct sockaddr *)&(_from), &(_fromlen)) \
        && errno \
        && ENOTCONN != errno \
        && ENOTSOCK != errno) \
      perror(STRINGJOIN(FUNC_NAME, "/getpeername")); \
  }

#if 0
#define CAN_STORE(_buf) \
  (1 == msg->msg_iovlen && 0 == msg->msg_accrightslen)
#else
#define CAN_STROE(_buf) 0 /* Q&D */
#endif


#define COPY_STOREDPACKET(_stored, _ret) \
{ \
  int tmpfromlen, tmpret; \
  tmpfromlen = MIN(msg->msg_namelen, (_stored)->addrlen); \
  memcpy(msg->msg_name, &(_stored)->addr, tmpfromlen); \
  msg->msg_namelen = tmpfromlen; \
  tmpret = MIN((_stored)->len, msg->msg_iov[0].iov_len); \
  memcpy(msg->msg_iov[0].iov_base, (_stored)->buf, tmpret); \
  msg->msg_iovlen = 1; \
  (_ret) = tmpret; \
}

int recvmsg(int fd, struct msghdr *msg, int flags)
{
  int len = 8192;
  void *buf = (void*) msg->msg_iov[0].iov_base;
  struct sockaddr dummyaddr, *from = &dummyaddr;
  int dummylen = sizeof dummyaddr, *fromlen = &dummylen;
  memset(&dummyaddr, '\0', sizeof dummyaddr);


#include "recv-common.ic"

}
