/*
 *	sendmsg.c
 */
#include "netbug.h"

#define FUNC_NAME "sendmsg"

int __libc_sendmsg(int, const struct msghdr *, int);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _to, _tolen) \
  __libc_sendmsg((_fd), msg, (_flags))

#define GETDESTPORT(_fd, _a, _to, _tolen) \
  if (SOCK_DGRAM == opt) { \
    (_a) = (struct sockaddr_in *)&(_to); \
    (_tolen) = sizeof (_to); \
    if (getpeername((_fd), &(_to), &(_tolen)) \
        && errno \
        && ENOTCONN != errno \
        && ENOTSOCK != errno) \
      perror(STRINGJOIN(FUNC_NAME, "/getpeername")); \
  }

#if 0
#define CAN_STORE(_buf) \
  (1 == msg->msg_iovlen && 0 == msg->msg_accrightslen)
#else
#define CAN_STROE(_buf) 0 /* Q&D */
#endif

#define DO_STOREDSYSCALL(_fd, _buf, _len, _flags, _to, _tolen) \
{ \
  struct msghdr tmpmsg; \
  struct iovec iov; \
  memset(&tmpmsg, '\0', sizeof tmpmsg); \
  memcpy(tmpmsg.msg_name, (_to), *(_tolen)); \
  tmpmsg.msg_namelen = *(_tolen); \
  tmpmsg.msg_iovlen = 1; \
  tmpmsg.msg_iov = &iov; \
  iov.iov_len = (_len); \
  iov.iov_base = (_buf); \
  DO_SYSCALL((_fd), &tmpmsg, 0, (_flags), 0, 0); \
}

int sendmsg(int fd, const struct msghdr *msg, int flags)
{
  struct sockaddr dummyaddr, *to = &dummyaddr;
  int tolen = sizeof *to;
  int len = msg->msg_iov[0].iov_len;
  char *buf = msg->msg_iov[0].iov_base;

  memset(&dummyaddr, '\0', sizeof dummyaddr);
  memcpy(&dummyaddr, msg->msg_name, msg->msg_namelen);

#include "send-common.ic"

}
