#ifndef VIDEO_H
#define VIDEO_H

#include <sys/types.h>

#define MOVIE_DIRECTORY "/home/pks-public/AudioVideo/movies/"


#define DGRAM_VIDEO 0
#define DGRAM_AUDIO 1
#define DGRAM_INFO  2
#define DGRAM_LAST  3

#define TRUE 1
#define FALSE 0


typedef struct video_header {
  int marker;
  int block_num;
  int block_size;
} video_h;

typedef struct audio_header {
  int marker;
} audio_h;

typedef struct
{
  int mark;
  int width, height, is_bw;
  int block_anz, bytes_per_block;
  int audio_buffer_size;
} FORMAT;

void init_audio_video(FORMAT *video, int picnum); 
void show_video(int offset);
int decomp_JPEG (char* data, int data_size, int offset);
int play_audio_block(char *data, size_t length);
int get_completed_audio_blocks();

#endif
