/*
 *	send.c
 */
#include "netbug.h"

#define FUNC_NAME "send"

int __libc_send(int, const void *, size_t, int);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _from, _fromlen) \
  __libc_send((_fd), (_buf), (_len), (_flags))


#define GETDESTPORT(_fd, _a, _to, _tolen) \
  if (SOCK_DGRAM == opt) { \
    (_a) = (struct sockaddr_in *)&(_to); \
    (_a)->sin_port = 0; \
    (_tolen) = sizeof (_to); \
    if (getpeername((_fd), &(_to), &(_tolen)) \
        && errno \
        && ENOTCONN != errno \
        && ENOTSOCK != errno) \
      perror(STRINGJOIN(FUNC_NAME, "/getpeername")); \
  }

#define COPYMSGBUF(_src, _dest, _len) \
  memcpy((_dst), (_src), (_len))

int send(int fd, const void *buf, size_t len, int flags)
{
  struct sockaddr dummyaddr, *to = &dummyaddr;
  int tolen = sizeof *to;

  memset(&dummyaddr, '\0', sizeof dummyaddr);

#include "send-common.ic"

}
