/*
 *	sendto.c
 */
#include "netbug.h"

#define FUNC_NAME "sendto"

int __libc_sendto(int, const void *, size_t, int, const struct sockaddr *,
		  socklen_t);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _to, _tolen) \
  __libc_sendto((_fd), (_buf), (_len), (_flags), (_to), (_tolen))

/* Last argument is  not a pointer. */
#define DO_STOREDSYSCALL(_fd, _buf, _len, _flags, _to, _tolen) \
  DO_SYSCALL((_fd), (_buf), (_len), (_flags), (_to), *(_tolen))

#define GETDESTPORT(_fd, _a, _to, _tolen) \
  (_a) = (struct sockaddr_in *)&_to;


#define COPYMSGBUF(_src, _dest, _len) \
  memcpy((_dst), (_src), (_len))

int sendto(int fd, const void *buf, size_t len, int flags, const struct sockaddr *to, size_t tolen)
{

#include "send-common.ic"

}
