#include "avformat.h"

t_rblock*	rblock_new(t_enBlockMarker marker);
t_rblock*	rblock_new_with_space(t_enBlockMarker marker, size_t space);
void		rblock_free(t_rblock* blk);

void		rblock_copy(t_rblock* src, t_rblock* dest);

size_t		rblock_send(int fd, t_rblock* block, int flags);
t_rblock*	rblock_recv(int fd, int flags);
int			rblock_recv_into(int fd, t_rblock* block, int flags, char payloadbuf[], size_t bufsize);


void		rblock_dump(t_rblock *block);
void		rblock_dump_payload(t_rblock *block);
/* vi:set tabstop=4 shiftwidth=4 noexpandtab: */
